'''
This code is part of Cosmic Commando; Copyright (C) 2012 Piotr 'ZasVid' Sikora; see CosmicCommando.py for full notice.
'''

import libtcodpy as libtcod
from debug import debug

default_color = libtcod.Color(0xff, 0x69, 0xb4) # hot pink ;)
default_shape = libtcod.CHAR_BLOCK3

shapes = {'space' : ' ', 'floor' : '.', 'water' : '~', 'wall' : '#', 
          'nothing' : ' ',
          'closed door':'|', 'open door':':', 
          'stairs down' : '>', 'stairs up' : '<', 'stairs next' : '>', 'stairs prev' : '<',
          'corpse' : '%',
          'player' : '@',
          'human' : '@', 'person' : '@',
          'Raven soldier' : '@', 'cybork' : 'O', 'mech' : 'M',
          'medical' : '+', 'ranged weapon' : '{', 'melee weapon' : '/', 'grenade' : '?'
          }
   
def _c(r,g,b):
    """ Shorten the notation. """
    return libtcod.Color(r,g,b) 
    
colors = {'black': libtcod.black, 'white': libtcod.white,
          'military': _c(70,96,49), 'electric': libtcod.light_cyan,
          'out of sight' : libtcod.darker_gray,
          'important' : libtcod.light_yellow,
          'player': libtcod.light_red,
          'blood red': _c(102,0,0),
          'Raven Rank 1' : _c(46,46,46), 'Raven Rank 2' : _c(92,92,92), 'Raven Rank 3' : _c(138,138,138), 'Raven Rank 4' : _c(184,184,184),
          'metallic green' : _c(161,203,121), 'metallic gray' : _c(162,162,162),
          'shields': libtcod.blue,'full shields' : _c(155,195,255), 'nearly full shields' : _c(115,155,225), 'still strong shields'  : _c(75,115,195), 'weakened shields' : _c(35,75,165), 'waning shields' : _c(0,45,135),
          'health': libtcod.red,'full health' : _c(255,225,225), 'nearly full health' : _c(255,180,180), 'still strong health'  : _c(255,120,120), 'weakened health' : _c(255,60,60), 'waning health' : _c(255,0,0),
          'me3 armor' : _c(241,192,38),
          }

def shape(shape_name):
    if shape_name not in shapes:
        debug.log("Missing shape: " + shape_name)
    return shapes.get(shape_name, default_shape)

def color(color_name):
    if color_name not in colors:
        try:
            color = eval('libtcod.'+color_name.replace(' ','_'))
            return color
        except AttributeError:
            debug.log("Missing color: "+color_name)
            return default_color
    return colors[color_name]
